summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--.gitignore1
-rw-r--r--Makefile1
-rw-r--r--README4
-rw-r--r--TODO2
-rw-r--r--debian/changelog15
-rw-r--r--debian/control2
-rwxr-xr-xdebootstrap4
-rw-r--r--debootstrap.84
-rw-r--r--functions5
l---------scripts/bullseye1
l---------scripts/buster1
l---------scripts/oldoldstable1
-rw-r--r--scripts/sid27
13 files changed, 46 insertions, 22 deletions
diff --git a/.gitignore b/.gitignore
deleted file mode 100644
index 8b13789..0000000
--- a/.gitignore
+++ /dev/null
@@ -1 +0,0 @@
-
diff --git a/Makefile b/Makefile
index 55f229d..8516803 100644
--- a/Makefile
+++ b/Makefile
@@ -1,6 +1,5 @@
# avoid dpkg-dev dependency; fish out the version with sed
VERSION := $(shell sed 's/.*(\(.*\)).*/\1/; q' debian/changelog)
-DATE := $(shell sed -n '/^ -- /{s/.*> \(.*\)/\1/p;q;}' debian/changelog)
all:
diff --git a/README b/README
index 47fdec6..1e9402a 100644
--- a/README
+++ b/README
@@ -10,7 +10,7 @@ You can run debootstrap from its source tree without installing it. This
can be useful if you want a quick way to make a Debian chroot on another
system, or if you are testing modifications to debootstrap.
-First, get the source.
+First, get the source.
* Either by using git
git clone https://anonscm.debian.org/git/d-i/debootstrap.git
@@ -41,7 +41,7 @@ Future
* Cross-strap support - so you can bootstrap a filesystem to the
point where it will successfully boot, and finish installing itself
without having to be running the target architecture or OS yourself.
- This means you should be able to run
+ This means you should be able to run
debootstrap --arch powerpc sarge ./sarge-ppc-chroot ...
diff --git a/TODO b/TODO
index e5fde0e..3a86214 100644
--- a/TODO
+++ b/TODO
@@ -7,5 +7,3 @@ Features:
-- versus command line
-- support for sources (vs mirrors)
-- faux-pinning for packages
-
- ++ makedev in second stage
diff --git a/debian/changelog b/debian/changelog
index 334bba5..c04bb03 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -7,6 +7,21 @@ debootstrap (1.0.85) UNRELEASED; urgency=medium
[ Colin Watson ]
* Add (Ubuntu) zesty as a symlink to gutsy.
+ [ Ansgar Burchardt ]
+ * Add jessie-kfreebsd to merged-/usr blacklist.
+ * No longer Build-Depend on makedev. The code using it was already
+ removed in debootstrap 1.0.82.
+ * Do not use `tar -k` for older releases which might have file
+ conflicts between the packages to be installed. (Closes: #838388)
+ * Error out when seeing short options. (Closes: #548880)
+ * Add oldoldstable -> sid script symlink. (Closes: #792734)
+ * Add buster -> sid and bullseye -> sid script symlinks.
+ * Only unpack and configure the base system when there are actually
+ packages to install. (Closes: #825034)
+
+ [ Marco d'Itri ]
+ * Enable merged-/usr by default. (Closes: #839046, #839162)
+
-- Julien Cristau <jcristau@debian.org> Fri, 02 Sep 2016 20:26:38 +0200
debootstrap (1.0.84) unstable; urgency=medium
diff --git a/debian/control b/debian/control
index 6f9fbb8..23371e9 100644
--- a/debian/control
+++ b/debian/control
@@ -3,7 +3,7 @@ Section: admin
Priority: extra
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Junichi Uekawa <dancer@debian.org>, Colin Watson <cjwatson@debian.org>, Christian Perrier <bubulle@debian.org>, Steve McIntyre <93sam@debian.org>
-Build-Depends: debhelper (>= 9), makedev (>= 2.3.1-69) [linux-any]
+Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/d-i/debootstrap.git
Vcs-Git: https://anonscm.debian.org/git/d-i/debootstrap.git
diff --git a/debootstrap b/debootstrap
index 084a541..0d6cb54 100755
--- a/debootstrap
+++ b/debootstrap
@@ -27,7 +27,7 @@ KEYRING=""
DISABLE_KEYRING=""
FORCE_KEYRING=""
VARIANT=""
-MERGED_USR="no"
+MERGED_USR="yes"
ARCH=""
HOST_ARCH=""
HOST_OS=""
@@ -360,7 +360,7 @@ if [ $# != 0 ] ; then
CHECKCERTIF="--no-check-certificate"
shift
;;
- --*)
+ -*)
error 1 BADARG "unrecognized or invalid option %s" "$1"
;;
*)
diff --git a/debootstrap.8 b/debootstrap.8
index 3d19683..bb590d7 100644
--- a/debootstrap.8
+++ b/debootstrap.8
@@ -86,6 +86,10 @@ Debian installation in
.IP
.IP "\fB\-\-merged-usr\fP"
Create /{bin,sbin,lib}/ symlinks pointing to their counterparts in /usr/.
+(Default.)
+.IP
+.IP "\fB\-\-no-merged-usr\fP"
+Do not create /{bin,sbin,lib}/ symlinks pointing to their counterparts in /usr/.
.IP
.IP "\fB\-\-keyring=KEYRING\fP"
Override the default keyring for the distribution being bootstrapped,
diff --git a/functions b/functions
index 5630d59..5f43865 100644
--- a/functions
+++ b/functions
@@ -836,6 +836,7 @@ get_debs () {
################################################################ extraction
EXTRACTORS_SUPPORTED="dpkg-deb ar"
+EXTRACT_DEB_TAR_OPTIONS=
# Native dpkg-deb based extractors
extract_dpkg_deb_field () {
@@ -848,7 +849,7 @@ extract_dpkg_deb_field () {
extract_dpkg_deb_data () {
local pkg="$1"
- dpkg-deb --fsys-tarfile "$pkg" | tar -kxf -
+ dpkg-deb --fsys-tarfile "$pkg" | tar $EXTRACT_DEB_TAR_OPTIONS -xf -
}
# Raw .deb extractors
@@ -886,7 +887,7 @@ extract_ar_deb_data () {
esac
if type $cat_cmd >/dev/null 2>&1; then
- ar -p "$pkg" "$tarball" | $cat_cmd | tar -kxf -
+ ar -p "$pkg" "$tarball" | $cat_cmd | tar $EXTRACT_DEB_TAR_OPTIONS -xf -
else
error 1 UNPACKCMDUNVL "Extracting %s requires the %s command, which is not available" "$pkg" "$cat_cmd"
fi
diff --git a/scripts/bullseye b/scripts/bullseye
new file mode 120000
index 0000000..9a63c96
--- /dev/null
+++ b/scripts/bullseye
@@ -0,0 +1 @@
+sid \ No newline at end of file
diff --git a/scripts/buster b/scripts/buster
new file mode 120000
index 0000000..9a63c96
--- /dev/null
+++ b/scripts/buster
@@ -0,0 +1 @@
+sid \ No newline at end of file
diff --git a/scripts/oldoldstable b/scripts/oldoldstable
new file mode 120000
index 0000000..9a63c96
--- /dev/null
+++ b/scripts/oldoldstable
@@ -0,0 +1 @@
+sid \ No newline at end of file
diff --git a/scripts/sid b/scripts/sid
index ceedd66..0b289f9 100644
--- a/scripts/sid
+++ b/scripts/sid
@@ -42,8 +42,11 @@ work_out_debs () {
first_stage_install () {
case "$CODENAME" in
- etch|etch-m68k|jessie|lenny|squeeze|wheezy) ;;
- *) setup_merged_usr ;;
+ etch|etch-m68k|jessie|jessie-kfreebsd|lenny|squeeze|wheezy) ;;
+ *)
+ EXTRACT_DEB_TAR_OPTIONS="$EXTRACT_DEB_TAR_OPTIONS -k"
+ setup_merged_usr
+ ;;
esac
extract $required
@@ -191,17 +194,19 @@ echo \"Warning: Fake start-stop-daemon called, doing nothing\"" > "$TARGET/sbin/
done_predeps="$done_predeps $predep"
done
- smallyes '' |
- (repeatn 5 in_target_failmsg INST_BASE_FAIL_FIVE "Failure while installing base packages. This will be re-attempted up to five times." "" \
- dpkg --status-fd 8 --force-overwrite --force-confold --skip-same-version --unpack $(debfor $base) 8>&1 1>&7 || echo EXITCODE $?) |
- dpkg_progress $baseprog $bases UNPACKBASE "Unpacking base system" UNPACKING
+ if [ -n "$base" ]; then
+ smallyes '' |
+ (repeatn 5 in_target_failmsg INST_BASE_FAIL_FIVE "Failure while installing base packages. This will be re-attempted up to five times." "" \
+ dpkg --status-fd 8 --force-overwrite --force-confold --skip-same-version --unpack $(debfor $base) 8>&1 1>&7 || echo EXITCODE $?) |
+ dpkg_progress $baseprog $bases UNPACKBASE "Unpacking base system" UNPACKING
- info CONFBASE "Configuring the base system..."
+ info CONFBASE "Configuring the base system..."
- smallyes '' |
- (repeatn 5 in_target_failmsg CONF_BASE_FAIL_FIVE "Failure while configuring base packages. This will be re-attempted up to five times." "" \
- dpkg --status-fd 8 --force-confold --skip-same-version --configure -a 8>&1 1>&7 || echo EXITCODE $?) |
- dpkg_progress $baseprog $bases CONFBASE "Configuring base system" CONFIGURING
+ smallyes '' |
+ (repeatn 5 in_target_failmsg CONF_BASE_FAIL_FIVE "Failure while configuring base packages. This will be re-attempted up to five times." "" \
+ dpkg --status-fd 8 --force-confold --skip-same-version --configure -a 8>&1 1>&7 || echo EXITCODE $?) |
+ dpkg_progress $baseprog $bases CONFBASE "Configuring base system" CONFIGURING
+ fi
mv "$TARGET/sbin/start-stop-daemon.REAL" "$TARGET/sbin/start-stop-daemon"
rm -f "$TARGET/usr/sbin/policy-rc.d"